import LngLat from '../../geo/lng_lat';
import Point from '../../geo/point';
import { Map } from '../../map';
import { Event } from './event';
export default class MapMouseEvent extends Event {
    /**
     * `true` if `preventDefault` has been called.
     * @private
     */
    type: 'mousedown' | 'mouseup' | 'click' | 'dblclick' | 'mousemove' | 'mouseover' | 'mouseenter' | 'mouseleave' | 'mouseout' | 'contextmenu';
    /**
     * The `Map` object that fired the event.
     */
    target: Map;
    /**
     * The DOM event which caused the map event.
     */
    originalEvent: MouseEvent;
    /**
     * The pixel coordinates of the mouse cursor, relative to the map and measured from the top left corner.
     */
    point: Point;
    /**
     * The geographic location on the map of the mouse cursor.
     */
    lngLat: LngLat;
    defaultPrevented: boolean;
    /**
     * @private
     */
    constructor(type: string, map: Map, originalEvent: MouseEvent, data?: any);
    preventDefault(): void;
}
