import { Map } from '../map';
import { IDragPanOptions } from './shim/drag_pan';
export interface IInertiaOptions {
    linearity: number;
    easing: (t: number) => number;
    deceleration: number;
    maxSpeed: number;
}
export declare type InputEvent = MouseEvent | TouchEvent | KeyboardEvent | WheelEvent;
export default class HandlerInertia {
    private map;
    private inertiaBuffer;
    constructor(map: Map);
    clear(): void;
    record(settings: any): void;
    drainInertiaBuffer(): void;
    onMoveEnd(panInertiaOptions?: IDragPanOptions): ({
        [key: string]: any;
    } & {
        noMoveStart: boolean;
    }) | undefined;
}
