import Point from '../geo/point';
import { Map } from '../map';
import { MapMouseEvent, MapTouchEvent, MapWheelEvent } from './events';
export default class MapEventHandler {
    private mousedownPos;
    private clickTolerance;
    private map;
    constructor(map: Map, options: {
        clickTolerance: number;
    });
    reset(): void;
    wheel(e: WheelEvent): {} | undefined;
    mousedown(e: MouseEvent, point: Point): {} | undefined;
    mouseup(e: MouseEvent): void;
    click(e: MouseEvent, point: Point): void;
    dblclick(e: MouseEvent): {} | undefined;
    mouseover(e: MouseEvent): void;
    mouseout(e: MouseEvent): void;
    touchstart(e: TouchEvent): {} | undefined;
    touchmove(e: TouchEvent): void;
    touchend(e: TouchEvent): void;
    touchcancel(e: TouchEvent): void;
    firePreventable(mapEvent: MapMouseEvent | MapTouchEvent | MapWheelEvent): {} | undefined;
    isEnabled(): boolean;
    isActive(): boolean;
    enable(): boolean;
    disable(): boolean;
}
