import Point from '../../geo/point';
export default class MouseHandler {
    protected enabled: boolean;
    protected active: boolean;
    protected lastPoint: Point;
    protected eventButton: 1 | 2;
    protected moved: boolean;
    protected clickTolerance: number;
    constructor(options: {
        clickTolerance: number;
    });
    reset(): void;
    mousedown(e: MouseEvent, point: Point): void;
    mousemoveWindow(e: MouseEvent, point: Point): void;
    mouseupWindow(e: MouseEvent): void;
    enable(): void;
    disable(): void;
    isEnabled(): boolean;
    isActive(): boolean;
    protected correctButton(e: MouseEvent, button: number): boolean;
    protected move(lastPoint: Point, point: Point): void;
}
