"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _glMatrix = require("gl-matrix");

var Frustum = function () {
  function Frustum(points, planes) {
    (0, _classCallCheck2.default)(this, Frustum);
    (0, _defineProperty2.default)(this, "points", void 0);
    (0, _defineProperty2.default)(this, "planes", void 0);
    this.points = points;
    this.planes = planes;
  }

  (0, _createClass2.default)(Frustum, null, [{
    key: "fromInvProjectionMatrix",
    value: function fromInvProjectionMatrix(invProj, worldSize, zoom) {
      var clipSpaceCorners = [[-1, 1, -1, 1], [1, 1, -1, 1], [1, -1, -1, 1], [-1, -1, -1, 1], [-1, 1, 1, 1], [1, 1, 1, 1], [1, -1, 1, 1], [-1, -1, 1, 1]];
      var scale = Math.pow(2, zoom);
      var frustumCoords = clipSpaceCorners.map(function (v) {
        return _glMatrix.vec4.transformMat4(new Float32Array([]), v, invProj);
      }).map(function (v) {
        return _glMatrix.vec4.scale(new Float32Array([]), v, 1.0 / v[3] / worldSize * scale);
      });
      var frustumPlanePointIndices = [[0, 1, 2], [6, 5, 4], [0, 3, 7], [2, 1, 5], [3, 2, 6], [0, 4, 5]];
      var frustumPlanes = frustumPlanePointIndices.map(function (p) {
        var a = _glMatrix.vec3.sub(new Float32Array(3), new Float32Array(frustumCoords[p[0]]), new Float32Array(frustumCoords[p[1]]));

        var b = _glMatrix.vec3.sub(new Float32Array(3), new Float32Array(frustumCoords[p[2]]), new Float32Array(frustumCoords[p[1]]));

        var n = _glMatrix.vec3.normalize(new Float32Array(3), _glMatrix.vec3.cross(new Float32Array(3), a, b));

        var d = -_glMatrix.vec3.dot(n, new Float32Array(frustumCoords[p[1]]));
        return n.concat(d);
      });
      return new Frustum(frustumCoords, frustumPlanes);
    }
  }]);
  return Frustum;
}();

exports.default = Frustum;
//# sourceMappingURL=primitives.js.map